stages:
  - build
  - test
  - deploy

variables:
  COMMIT_IMAGE: $DOCKER_REGISTRY_USER/ci-testing:$CI_COMMIT_REF_NAME-$CI_COMMIT_SHORT_SHA
  BRANCH_IMAGE: $DOCKER_REGISTRY_USER/ci-testing:$CI_COMMIT_REF_NAME
  MINIMUM_COVRAGE: 75 # every *.py must have at least this percent coverage to pass

build:
  stage: build
  image: docker:latest
  services:
    - docker:dind
  before_script:
    - docker login -u "$DOCKER_REGISTRY_USER" -p "$DOCKER_REGISTRY_PASSWORD"
  script:
    - docker build -t $COMMIT_IMAGE .
    - docker tag $COMMIT_IMAGE $BRANCH_IMAGE
    - docker push $COMMIT_IMAGE
    - docker push $BRANCH_IMAGE

flake8:
  stage: test
  image: $COMMIT_IMAGE
  services:
    - $COMMIT_IMAGE
  script:
    - flake8 --max-complexity 10 .

pylint:
  stage: test
  image: $COMMIT_IMAGE
  services:
    - $COMMIT_IMAGE
  script:
    - pylint ./*.py

test_code:
  stage: test
  image: $COMMIT_IMAGE
  services:
    - $COMMIT_IMAGE
  script:
    - pytest --cov-report html:cov_html --cov-fail-under=$MINIMUM_COVRAGE --cov=/app /app
  coverage: '/Total coverage: \d+\.\d+/'
  artifacts:
    when: always
    paths:
      - cov_html/

deploy_production:
  stage: deploy
  script:
    - echo "Deploy to production server"
  environment:
    name: production
    url: https://ci-testing.prod.com
  when: manual
  only:
    - master

deploy_non_production:
  stage: deploy
  script:
    - echo "Deploy to branch server"
  environment:
    name: $CI_COMMIT_REF_NAME
    url: https://ci-testing.$CI_COMMIT_REF_NAME.com
  except:
    - master
